﻿// ------------------------------------------------------------
// The code in this repository code was written by Lee Campbell, as a
// derived work from the original Java by Gil Tene of Azul Systems and
// Michael Barker, and released to the public domain, as explained
// at http://creativecommons.org/publicdomain/zero/1.0/
// ------------------------------------------------------------

// This file isn't generated, but this comment is necessary to exclude it from StyleCop analysis.
// <auto-generated/>

namespace HdrHistogram.Encoding
{
    /// <summary>
    /// Defines the histogram data to be recorded
    /// </summary>
    internal interface IRecordedData
    {
        /// <summary>
        /// The cookie value for the histogram.
        /// </summary>
        int Cookie { get; }
        /// <summary>
        /// The normalizing index offset.
        /// </summary>
        int NormalizingIndexOffset { get; } //Required? What is it?
        /// <summary>
        /// THe number of significant digits that values are measured to.
        /// </summary>
        int NumberOfSignificantValueDigits { get; }
        /// <summary>
        /// The lowest trackable value for the histogram
        /// </summary>
        long LowestDiscernibleValue { get; }        //TODO: Use either LowestDiscernibleValue or LowestTrackableUnitValue but not both. -LC
        /// <summary>
        /// The highest trackable value for the histogram
        /// </summary>
        long HighestTrackableValue { get; }
        /// <summary>
        /// Integer to double conversion ratio.
        /// </summary>
        double IntegerToDoubleValueConversionRatio { get; }
        /// <summary>
        /// The actual array of counts.
        /// </summary>
        long[] Counts { get; }
    }
}
