﻿//------------------------------------------------------------
// Copyright (c) Microsoft Corporation.  All rights reserved.
//------------------------------------------------------------

namespace Microsoft.Azure.Cosmos
{
    /// <summary>
    /// The LocationNames class contains the names of Azure regions that
    /// are currently supported by the Azure Cosmos DB service.
    /// </summary>
    public static class Regions
    {
        /// <summary>
        /// Name of the Azure West US region in the Azure Cosmos DB service.
        /// </summary>
        public const string WestUS = "West US";

        /// <summary>
        /// Name of the Azure West US 2 region in the Azure Cosmos DB service.
        /// </summary>
        public const string WestUS2 = "West US 2";

        /// <summary>
        /// Name of the Azure West Central US region in the Azure Cosmos DB service.
        /// </summary>
        public const string WestCentralUS = "West Central US";

        /// <summary>
        /// Name of the Azure East US region in the Azure Cosmos DB service.
        /// </summary>
        public const string EastUS = "East US";

        /// <summary>
        /// Name of the Azure East US 2 region in the Azure Cosmos DB service.
        /// </summary>
        public const string EastUS2 = "East US 2";

        /// <summary>
        /// Name of the Azure Central US region in the Azure Cosmos DB service.
        /// </summary>
        public const string CentralUS = "Central US";

        /// <summary>
        /// Name of the Azure Sourth Central US region in the Azure Cosmos DB service.
        /// </summary>
        public const string SouthCentralUS = "South Central US";

        /// <summary>
        /// Name of the Azure North Central US region in the Azure Cosmos DB service.
        /// </summary>
        public const string NorthCentralUS = "North Central US";

        /// <summary>
        /// Name of the Azure West Europe region in the Azure Cosmos DB service.
        /// </summary>
        public const string WestEurope = "West Europe";

        /// <summary>
        /// Name of the Azure North Europe region in the Azure Cosmos DB service.
        /// </summary>
        public const string NorthEurope = "North Europe";

        /// <summary>
        /// Name of the Azure East Asia region in the Azure Cosmos DB service.
        /// </summary>
        public const string EastAsia = "East Asia";

        /// <summary>
        /// Name of the Azure Southeast Asia region in the Azure Cosmos DB service.
        /// </summary>
        public const string SoutheastAsia = "Southeast Asia";

        /// <summary>
        /// Name of the Azure Japan East region in the Azure Cosmos DB service.
        /// </summary>
        public const string JapanEast = "Japan East";

        /// <summary>
        /// Name of the Azure Japan West region in the Azure Cosmos DB service.
        /// </summary>
        public const string JapanWest = "Japan West";

        /// <summary>
        /// Name of the Azure Australia East region in the Azure Cosmos DB service.
        /// </summary>
        public const string AustraliaEast = "Australia East";

        /// <summary>
        /// Name of the Azure Australia Southeast region in the Azure Cosmos DB service.
        /// </summary>
        public const string AustraliaSoutheast = "Australia Southeast";

        /// <summary>
        /// Name of the Azure Central India region in the Azure Cosmos DB service.
        /// </summary>
        public const string CentralIndia = "Central India";

        /// <summary>
        /// Name of the Azure South India region in the Azure Cosmos DB service.
        /// </summary>
        public const string SouthIndia = "South India";

        /// <summary>
        /// Name of the Azure West India region in the Azure Cosmos DB service.
        /// </summary>
        public const string WestIndia = "West India";

        /// <summary>
        /// Name of the Azure Canada East region in the Azure Cosmos DB service.
        /// </summary>
        public const string CanadaEast = "Canada East";

        /// <summary>
        /// Name of the Azure Canada Central region in the Azure Cosmos DB service.
        /// </summary>
        public const string CanadaCentral = "Canada Central";

        /// <summary>
        /// Name of the Azure Germany Central region in the Azure Cosmos DB service.
        /// </summary>
        public const string GermanyCentral = "Germany Central";

        /// <summary>
        /// Name of the Azure Germany Northeast region in the Azure Cosmos DB service.
        /// </summary>
        public const string GermanyNortheast = "Germany Northeast";

        /// <summary>
        /// Name of the Azure China North region in the Azure Cosmos DB service.
        /// </summary>
        public const string ChinaNorth = "China North";

        /// <summary>
        /// Name of the Azure China East region in the Azure Cosmos DB service.
        /// </summary>
        public const string ChinaEast = "China East";

        /// <summary>
        /// Name of the Azure China North 2 region in the Azure Cosmos DB service.
        /// </summary>
        public const string ChinaNorth2 = "China North 2";

        /// <summary>
        /// Name of the Azure China East 2 region in the Azure Cosmos DB service.
        /// </summary>
        public const string ChinaEast2 = "China East 2";

        /// <summary>
        /// Name of the Azure Korea South region in the Azure Cosmos DB service.
        /// </summary>
        public const string KoreaSouth = "Korea South";

        /// <summary>
        /// Name of the Azure Korea Central region in the Azure Cosmos DB service.
        /// </summary>
        public const string KoreaCentral = "Korea Central";

        /// <summary>
        /// Name of the Azure UK West region in the Azure Cosmos DB service.
        /// </summary>
        public const string UKWest = "UK West";

        /// <summary>
        /// Name of the Azure UK South region in the Azure Cosmos DB service.
        /// </summary>
        public const string UKSouth = "UK South";

        /// <summary>
        /// Name of the Azure Brazil South region in the Azure Cosmos DB service.
        /// </summary>
        public const string BrazilSouth = "Brazil South";

        /// <summary>
        /// Name of the Azure USGov Arizona region in the Azure Cosmos DB service.
        /// </summary>
        public const string USGovArizona = "USGov Arizona";

        /// <summary>
        /// Name of the Azure USGov Texas region in the Azure Cosmos DB service.
        /// </summary>
        public const string USGovTexas = "USGov Texas";

        /// <summary>
        /// Name of the Azure USGov Virginia region in the Azure Cosmos DB service.
        /// </summary>
        public const string USGovVirginia = "USGov Virginia";

        /// <summary>
        /// Name of the Azure East US 2 Early Updates Access Program (EUAP) region in the Azure Cosmos DB service.
        /// </summary>
        public const string EastUS2EUAP = "East US 2 EUAP";

        /// <summary>
        /// Name of the Azure Central US Early Updates Access Program (EUAP) region in the Azure Cosmos DB service.
        /// </summary>
        public const string CentralUSEUAP = "Central US EUAP";

        /// <summary>
        /// Name of the Azure France Central region in the Azure Cosmos DB service.
        /// </summary>
        public const string FranceCentral = "France Central";

        /// <summary>
        /// Name of the Azure France South region in the Azure Cosmos DB service.
        /// </summary>
        public const string FranceSouth = "France South";

        /// <summary>
        /// Name of the Azure DoD Central region in the Azure Cosmos DB service.
        /// </summary>
        public const string USDoDCentral = "USDoD Central";

        /// <summary>
        /// Name of the Azure DoD East region in the Azure Cosmos DB service.
        /// </summary>
        public const string USDoDEast = "USDoD East";

        /// <summary>
        /// Name of the Azure Australia Central region in the Azure Cosmos DB service.
        /// </summary>
        public const string AustraliaCentral = "Australia Central";

        /// <summary>
        /// Name of the Azure Australia Central 2 region in the Azure Cosmos DB service.
        /// </summary>
        public const string AustraliaCentral2 = "Australia Central 2";

        /// <summary>
        /// Name of the Azure South Africa North region in the Azure Cosmos DB service.
        /// </summary>
        public const string SouthAfricaNorth = "South Africa North";

        /// <summary>
        /// Name of the Azure South Africa West region in the Azure Cosmos DB service.
        /// </summary>
        public const string SouthAfricaWest = "South Africa West";

        /// <summary>
        /// Name of the Azure UAE Central region in the Azure Cosmos DB service.
        /// </summary>
        public const string UAECentral = "UAE Central";

        /// <summary>
        /// Name of the Azure UAE North region in the Azure Cosmos DB service.
        /// </summary>
        public const string UAENorth = "UAE North";

        /// <summary>
        /// Name of the Azure USNat East region in the Azure Cosmos DB service.
        /// </summary>
        public const string USNatEast = "USNat East";

        /// <summary>
        /// Name of the Azure USNat West region in the Azure Cosmos DB service.
        /// </summary>
        public const string USNatWest = "USNat West";

        /// <summary>
        /// Name of the Azure USSec East region in the Azure Cosmos DB service.
        /// </summary>
        public const string USSecEast = "USSec East";

        /// <summary>
        /// Name of the Azure USNat West region in the Azure Cosmos DB service.
        /// </summary>
        public const string USSecWest = "USSec West";

        /// <summary>
        /// Name of the Azure Switzerland North region in the Azure Cosmos DB service.
        /// </summary>
        public const string SwitzerlandNorth = "Switzerland North";

        /// <summary>
        /// Name of the Azure Switzerland West region in the Azure Cosmos DB service.
        /// </summary>
        public const string SwitzerlandWest = "Switzerland West";

        /// <summary>
        /// Name of the Azure Germany North region in the Azure Cosmos DB service.
        /// </summary>
        public const string GermanyNorth = "Germany North";

        /// <summary>
        /// Name of the Azure Germany West Central region in the Azure Cosmos DB service.
        /// </summary>
        public const string GermanyWestCentral = "Germany West Central";

        /// <summary>
        /// Name of the Azure Norway East region in the Azure Cosmos DB service.
        /// </summary>
        public const string NorwayEast = "Norway East";

        /// <summary>
        /// Name of the Azure Norway West region in the Azure Cosmos DB service.
        /// </summary>
        public const string NorwayWest = "Norway West";

        /// <summary>
        /// Name of the Azure Brazil Southeast region in the Azure Cosmos DB service.
        /// </summary>
        public const string BrazilSoutheast = "Brazil Southeast";

        /// <summary>
        /// Name of the Azure West US 3 region in the Azure Cosmos DB service.
        /// </summary>
        public const string WestUS3 = "West US 3";

        /// <summary>
        /// Name of the Azure Jio India Central region in the Azure Cosmos DB service.
        /// </summary>
        public const string JioIndiaCentral = "Jio India Central";

        /// <summary>
        /// Name of the Azure Jio India West region in the Azure Cosmos DB service.
        /// </summary>
        public const string JioIndiaWest = "Jio India West";

        /// <summary>
        /// Name of the Azure East US SLV region in the Azure Cosmos DB service.
        /// </summary>
        public const string EastUSSLV = "East US SLV";

        /// <summary>
        /// Name of the Azure Sweden Central region in the Azure Cosmos DB service.
        /// </summary>
        public const string SwedenCentral = "Sweden Central";

        /// <summary>
        /// Name of the Azure Sweden South region in the Azure Cosmos DB service.
        /// </summary>
        public const string SwedenSouth = "Sweden South";

        /// <summary>
        /// Name of the Azure Qatar Central region in the Azure Cosmos DB service.
        /// </summary>
        public const string QatarCentral = "Qatar Central";

        /// <summary>
        /// Name of the Azure China North 3 region in the Azure Cosmos DB service.
        /// </summary>
        public const string ChinaNorth3 = "China North 3";

        /// <summary>
        /// Name of the Azure China East 3 region in the Azure Cosmos DB service.
        /// </summary>
        public const string ChinaEast3 = "China East 3";

        /// <summary>
        /// Name of the Azure Poland Central region in the Azure Cosmos DB service.
        /// </summary>
        public const string PolandCentral = "Poland Central";

        /// <summary>
        /// Name of the Azure Malaysia South region in the Azure Cosmos DB service.
        /// </summary>
        public const string MalaysiaSouth = "Malaysia South";

        /// <summary>
        /// Name of the Azure Italy North region in the Azure Cosmos DB service.
        /// </summary>
        public const string ItalyNorth = "Italy North";

        /// <summary>
        /// Name of the Azure Israel Central region in the Azure Cosmos DB service.
        /// </summary>
        public const string IsraelCentral = "Israel Central";

        /// <summary>
        /// Name of the Azure Mexico Central region in the Azure Cosmos DB service.
        /// </summary>
        public const string MexicoCentral = "Mexico Central";

        /// <summary>
        /// Name of the Azure Spain Central region in the Azure Cosmos DB service.
        /// </summary>
        public const string SpainCentral = "Spain Central";
    }
}
